#!/usr/bin/env python

"""
Given a bunch of printed out parse trees, extract the (weighted) grammar
"""

import sys
import nltk
from nltk.grammar import Nonterminal
from nltk.tree import Tree
from nltk.tree import bracket_parse
from util import production_sort

def main():
    if len(sys.argv) != 2:
        print "usage: python grammar_from_trees.py trees"
        return

    lines = open(sys.argv[1]).readlines()

    productions = []

    for line in lines:
        tree = bracket_parse(line)
        withtop = Tree("TOP", [tree])
        productions += withtop.productions()

    grammar = nltk.grammar.induce_pcfg(Nonterminal("TOP"), productions)
    theproductions = grammar.productions()
    theproductions.sort(cmp=production_sort)
    for prod in theproductions:
        print prod

if __name__ == '__main__':
    main()
